;;;
;;; this file is common to all Nextstep MIDI implementations.
;;; 

(in-package :cm)

;;;
;;; %midi-open port reference can be -1, 0, 1, or 2:
;;; port -1 = open in default configuration (serial A on Next).
;;; port  0 = open serial A
;;; port  1 = open serial B
;;; port  2 = open serial A+B
;;;

(defun %midi-open (port &aux flg)
  (cond ((= port -1) (setf port 0) )  ; default = port A
        ((< port 3) )
        (t (error "No such port: ~D" port)))
  (setf flg (%%midi-open port))
  (when (= flg +midi-success+ )
    (setf *midi-open* (elt *port-refs* port)))
  flg)

(defun midi-input-hook (event time)
  (declare (special *midi-read-hook*) 
           (optimize (speed 3) (safety 0)))
  (when *midi-read-hook*
    (funcall (the function *midi-read-hook*)
	     (the fixnum event) (the fixnum time))))

(defun %midi-default-channel-map (port)
  (declare (ignore port))
  (default-midi-channel-map))
