
;; create packages

(progn 
  #-clisp (make-package :common-music :nicknames '(:cm))
  (make-package :tl)
  (make-package :clm)
  (make-package :pcl)
  (in-package :cm) )

;; Directory locations and file extensions which will change across platforms.

;(setf cm-directory "/u/lisp/bin/aclbin/cm/")
(setf cm-directory "~/SysDev/Music/CommonMusic/cm/midi/")
(setf source-extn ".lisp")
(setf obj-extn ".fas")

;; load midi

(progn
  (defconstant +midi-type+ "midi")
  #+clisp (load (concatenate 'string cm-directory "../extern/loop.lisp"))
  #+clisp (pushnew :next *features*)
  (compile-file (concatenate 'string cm-directory "ml" source-extn))
  (load (concatenate 'string cm-directory "ml" obj-extn))
  #+acl (load (concatenate 'string cm-directory "next/next-midi.o" :system-libraries '("sys_s"))) 
  #+acl (load (concatenate 'string cm-directory "acl-next-midi.fasl"))
  #+clisp (compile-file (concatenate 'string cm-directory "next/clisp-next-midi" source-extn))
  #+clisp (load (concatenate 'string cm-directory "next/clisp-next-midi" obj-extn))
  (compile-file (concatenate 'string cm-directory "next/next-aux-midi" source-extn))
  (load (concatenate 'string cm-directory "next/next-aux-midi" obj-extn))
  (compile-file (concatenate 'string cm-directory "md" source-extn))
  (load (concatenate 'string cm-directory "md" obj-extn))
  (compile-file (concatenate 'string cm-directory "mf" source-extn))
  (load (concatenate 'string cm-directory "mf" obj-extn)) )

(in-package :cm) 

(defun warn-user (&rest args) (apply #'warn args))

(defun test (times port) ; 0,1,2
  (loop with dur = 90
        with rhy = 100
        with time = (midi-get-time)
        repeat times
        for key = (+ 10 (random 117))
        for unit = (if (= port 2) (random 2) port)
        do
        (midi-write-message (make-note-on 0 key 127 unit) time)
        (incf time dur) 
        (midi-write-message (make-note-off 0 key 127 unit)
                                (+ time dur))
        (incf time rhy)))

(compile 'test)

#|

(midi-open :port 'a)
(test 500 0)
(midi-close)
(midi-open :port 'b)
(test 500 1)
(midi-close)
(midi-open :port 'a+b)
(test 500 2)

(midi-open :port :A)
(midi-write-message (make-note-on 0 60 60))
(midi-write-message (make-note-on 0 60 0))
(midi-close)

|#
